SystemOrganization addCategory: #ConfigurationOfGlorp!

Object subclass: #ConfigurationOfGlorp
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGlorp'!

!ConfigurationOfGlorp class methodsFor: 'private' stamp: 'GuillermoPolito 4/16/2011 22:08'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfGlorp class methodsFor: 'private' stamp: 'MarianoMartinezPeck 8/31/2011 12:18'!
ensureMetacello
        "Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
         Gofer API), then load the latest version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [ | error |
                "list of repositories to try, in case primary repository is not accessible"
                (Array 
                        with: 'http://www.squeaksource.com/MetacelloRepository' 
                        with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
                                ([
                                        Smalltalk at: #Gofer ifAbsent: [
                                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
                                                self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
                                        Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                                                gofer := goferClass new
                                                        url: repositoryUrl;
                                                        yourself.
                                                [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                                                gofer load ]]
                                                        on: Error
                                                        do: [ :ex |
                                                                error := ex.
                                                                Transcript 
                                                                        cr; 
                                                                        show: 'failed ensureMetacello: ';
                                                                        show: ex description printString;
                                                                        show: '...retrying'.
                                                                "try again"
                                                                ex return: nil ]) ~~ nil
                                        ifTrue: [
                                                "load 'default' group of Metacello"
                                                (Smalltalk at: #ConfigurationOfMetacello) perform: #load.
                                                ^self ]].
                "shouldn't get here unless the load failed ... throw an error"
                self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfGlorp class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 4/16/2011 22:08'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGlorp class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 4/16/2011 22:08'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfGlorp class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 4/16/2011 22:08'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfGlorp class methodsFor: 'accessing' stamp: 'GuillermoPolito 4/16/2011 22:08'!
project

	^self new project! !

!ConfigurationOfGlorp methodsFor: 'baselines' stamp: 'GuillermoPolito 4/16/2011 22:28'!
baseline10: spec
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/DBXTalk'.
		spec package: 'Glorp'.
		spec package: 'GlorpTests' with: [ spec requires: 'Glorp' ].
		
		spec group: 'default' with: #( 'Glorp' ).
		spec group: 'Dev' with: #( 'default' 'GlorpTests' ). ].! !

!ConfigurationOfGlorp methodsFor: 'baselines' stamp: 'GuillermoPolito 9/19/2011 01:08'!
baseline11: spec
	<version: '1.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/DBXTalk'.
		spec package: 'Glorp'.
		spec package: 'GlorpPharoCompatibility'.
		spec package: 'GlorpAnalysis' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecord' with: [ spec requires: #('Glorp' 'GlorpAnalysis') ].
		spec package: 'GlorpTests' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecordTests' with: [ spec requires: #( 'Glorp' 'GlorpTests') ].
		
		spec group: 'default' with: #( 'Glorp' 'GlorpTests' 'GlorpPharoCompatibility'). 
	]! !

!ConfigurationOfGlorp methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 12/27/2011 17:54'!
baseline12: spec
	<version: '1.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/DBXTalk'.
		spec package: 'Glorp'.
		spec package: 'GlorpPharoCompatibility'.
		spec package: 'GlorpAnalysis' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecord' with: [ spec requires: #('Glorp' 'GlorpAnalysis') ].
		spec package: 'GlorpTests' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecordTests' with: [ spec requires: #( 'Glorp' 'GlorpTests') ].
		
		spec 
			group: 'default' with: #( 'Glorp' 'GlorpTests' 'GlorpPharoCompatibility');
			group: 'DeveloperGroup' with: 'ALL'.
	]! !

!ConfigurationOfGlorp methodsFor: 'baselines' stamp: 'GuillermoPolito 2/1/2013 17:43'!
baseline13: spec
	"Migration to smalltalkhub"
	<version: '1.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.smalltalkhub.com/mc/DBXTalk/Glorp/main'.
		spec package: 'Glorp'.
		spec package: 'GlorpPharoCompatibility'.
		spec package: 'GlorpAnalysis' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecord' with: [ spec requires: #('Glorp' 'GlorpAnalysis') ].
		spec package: 'GlorpTests' with: [ spec requires: 'Glorp' ].
		spec package: 'GlorpActiveRecordTests' with: [ spec requires: #( 'Glorp' 'GlorpTests') ].
		
		spec 
			group: 'default' with: #( 'Glorp' 'GlorpTests' 'GlorpPharoCompatibility');
			group: 'DeveloperGroup' with: 'ALL'.
	]! !

!ConfigurationOfGlorp methodsFor: 'accessing' stamp: 'GuillermoPolito 4/16/2011 22:08'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project ]! !

!ConfigurationOfGlorp methodsFor: 'baselines' stamp: 'GuillermoPolito 2/1/2013 17:43'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'pharo1.2.x' version: '1.2'. 
	spec for: #'pharo1.3.x' version: '1.2'. 
	spec for: #'pharo1.4.x' version: '1.4'. 
! !

!ConfigurationOfGlorp methodsFor: 'versions' stamp: 'GuillermoPolito 6/12/2011 02:56'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #stable.
		spec package: 'Glorp' with: 'Glorp-GuillermoPolito.72'. 
		spec package: 'GlorpTests' with: 'GlorpTests-GuillermoPolito.22'. ]! !

!ConfigurationOfGlorp methodsFor: 'versions' stamp: 'GuillermoPolito 9/25/2011 16:47'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'Glorp' with: 'Glorp-GuillermoPolito.82'.
		spec package: 'GlorpAnalysis' with: 'GlorpAnalysis-GuillermoPolito.1'.
		spec package: 'GlorpActiveRecord' with: 'GlorpActiveRecord-GuillermoPolito.1'. 
		spec package: 'GlorpActiveRecordTests' with: 'GlorpActiveRecordTests-GuillermoPolito.1'. 
		spec package: 'GlorpTests' with: 'GlorpTests-GuillermoPolito.30'. ]! !

!ConfigurationOfGlorp methodsFor: 'versions' stamp: 'GuillermoPolito 12/23/2011 20:10'!
version12: spec
	<version: '1.2' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'Glorp' with: 'Glorp-GuillermoPolito.85'.
		spec package: 'GlorpAnalysis' with: 'GlorpAnalysis-GuillermoPolito.1'.
		spec package: 'GlorpActiveRecord' with: 'GlorpActiveRecord-GuillermoPolito.1'. 
		spec package: 'GlorpActiveRecordTests' with: 'GlorpActiveRecordTests-GuillermoPolito.1'. 
		spec package: 'GlorpPharoCompatibility' with: 'GlorpPharoCompatibility-GuillermoPolito.3'.
		spec package: 'GlorpTests' with: 'GlorpTests-GuillermoPolito.33'. ]! !

!ConfigurationOfGlorp methodsFor: 'versions' stamp: 'GuillermoPolito 4/19/2012 17:31'!
version13: spec
	<version: '1.3' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'Glorp' with: 'Glorp-GuillermoPolito.85'.
		spec package: 'GlorpAnalysis' with: 'GlorpAnalysis-GuillermoPolito.1'.
		spec package: 'GlorpActiveRecord' with: 'GlorpActiveRecord-GuillermoPolito.1'. 
		spec package: 'GlorpActiveRecordTests' with: 'GlorpActiveRecordTests-GuillermoPolito.1'. 
		spec package: 'GlorpPharoCompatibility' with: 'GlorpPharoCompatibility-GuillermoPolito.4'.
		spec package: 'GlorpTests' with: 'GlorpTests-GuillermoPolito.33'. ]! !

!ConfigurationOfGlorp methodsFor: 'versions' stamp: 'GuillermoPolito 2/1/2013 17:43'!
version14: spec
	<version: '1.4' imports: #('1.3-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec package: 'Glorp' with: 'Glorp-GuillermoPolito.85'.
		spec package: 'GlorpAnalysis' with: 'GlorpAnalysis-GuillermoPolito.1'.
		spec package: 'GlorpActiveRecord' with: 'GlorpActiveRecord-GuillermoPolito.1'. 
		spec package: 'GlorpActiveRecordTests' with: 'GlorpActiveRecordTests-GuillermoPolito.1'. 
		spec package: 'GlorpPharoCompatibility' with: 'GlorpPharoCompatibility-GuillermoPolito.4'.
		spec package: 'GlorpTests' with: 'GlorpTests-GuillermoPolito.33'. ]! !
